﻿import tornado.web

class InputMap(object):
	uimodules = {'categories':'Category', 'customers':'Customer', 'customercustomerdemos':'CustomerCustomerDemo', 'customerdemographics':'CustomerDemographic', 'employees':'Employee', 'employeeterritories':'EmployeeTerritory', 'orders':'Order', 'orderdetails':'OrderDetail', 'products':'Product', 'regions':'Region', 'shippers':'Shipper', 'suppliers':'Supplier', 'territories':'Territory' }

class Pager(tornado.web.UIModule):
    """
    Generic pager for displaying list data
    
    {% module Pager('/db/categories', pager) %}
    """
    def render(self, url, pager):
        return self.render_string('uimodules\\Pager.html', url=url, pager=pager)

class ListData(tornado.web.UIModule):
    """
    Generic module for displaying entity data from sqlalchemy
    
    {% module ListData(input, data) %}    
    """
    def render(self, input, data, pager):
        return self.render_string('uimodules\\'+InputMap.uimodules[input.lower()]+'List.html', data=data, pager=pager)

class EditForm(tornado.web.UIModule):
    """
    Generic module for displaying an entity edit form
    
    {% module EditForm(input, data) %}    
    """
    def render(self, input, data, related):
        return self.render_string('uimodules\\'+InputMap.uimodules[input.lower()]+'Form.html', data=data, related=related, action='edit')

class ViewForm(tornado.web.UIModule):
    """
    Generic module for displaying an entity view form
    
    {% module ViewForm(input, data) %}    
    """
    def render(self, input, data, related):
        return self.render_string('uimodules\\'+InputMap.uimodules[input.lower()]+'Form.html', data=data, related=related, action='view')

class AddForm(tornado.web.UIModule):
    """
    Generic module for displaying an entity create form
    
    {% module AddForm(input, data) %}    
    """
    def render(self, input, data, related):
        return self.render_string('uimodules\\'+InputMap.uimodules[input.lower()]+'Form.html', data=data, related=related, action='add')

class SearchForm(tornado.web.UIModule):
    """
    Generic module for displaying an entity search form
    
    {% module SearchForm(input, data) %}    
    """
    def render(self, input, data, related):
        return self.render_string('uimodules\\'+InputMap.uimodules[input.lower()]+'Search.html', data=data, related=related, action='search')
